// @ts-nocheck

var showingRebelConf;
var anyRemoteServerDefined = false;

$(function () {

  console.log('in script');

  function expandCollapseDetails(button) {
    let projectId = $(button).prop('id').replace(/-details-button$/, "");
    let detailsDiv = $('#' + projectId + "-details-div");
    if (detailsDiv.hasClass('details-expanded')) {
      detailsDiv.removeClass('details-expanded');
      $(button).removeClass('details-expanded');
      $('#' + projectId + '-project-row').find('.div-table-cell').removeClass('expanded-table-cell');
    }
    else {
      collapseAll();
      detailsDiv.addClass('details-expanded');
      $(button).addClass('details-expanded');
      $('#' + projectId + '-project-row').find('.div-table-cell').addClass('expanded-table-cell');
    }
  }

  function collapseAll() {
    $('.details-row').removeClass('details-expanded');
    $('.details-button').removeClass('details-expanded');
    $('.div-table-cell').removeClass('expanded-table-cell');
  }

  function bindProjectRows() {

    $('.details-button').click(e => {
      expandCollapseDetails(e.target);
    });

    $('#projects-table-body .jrebel-onoff').change(e => {
      vscode.postMessage({ handlerId: 'projectpanel', type: 'jrebelToggled', projectName: $(e.target).attr('aria-project-name'), enable: e.target.checked || false });
    });

    const projectPanelDiv = $('#projectpanel-section-div');
    projectPanelDiv.find('.in-table-push').click(e => {
      vscode.postMessage({ handlerId: 'projectpanel', type: 'openConfigureJRebelDialog', projectName: $(e.target).attr('aria-project-name') });
    });

    $('#projects-table-body .remote-onoff').on('change', e => {
      vscode.postMessage({ handlerId: 'projectpanel', type: 'remotingToggled', projectName: $(e.target).attr('aria-project-name'), enable: e.target.checked || false });
    });
  }

  /* === Configure JRebel Dialog STARTS === */


  const configureJRebelModal = $("#configure-jrebel-modal");
  const configureJRebelModalCancel = $("#button-cancel-configure-jrebel-modal");
  const configureJrebelModalOk = $("#button-ok-configure-jrebel-modal");

  const closeModal = function () {
    configureJRebelModal.css('display', 'none');
    configureJRebelModal.removeClass('disable-div');
    vscode.postMessage({ handlerId: 'projectpanel', type: 'closedConfigureJRebelDialog' });
  };

  configureJRebelModalCancel.click(closeModal);

  function getRebelConfFromUI() {
    return {
      isJRebelProject: showingRebelConf.isJRebelProject,
      isJRebelRemotingProject: showingRebelConf.isJRebelRemotingProject,
      useRelativePaths: configureJRebelModal.find('#use-relative-paths-in-rebel-xml').prop('checked') || false,
      isIdeRebelXmlGenerationType: configureJRebelModal.find('#generate-rebel-xml-by-ide').prop('checked') || false,
      hasCustomXmlDirectory: configureJRebelModal.find('#override-configuration-file-location').prop('checked') || false,
      customXmlDirectoryPath: configureJRebelModal.find('#configuration-file-location').val(),
      remotingConf: getRemotingConfFromUI()
    };
  }

  function getRemotingConfFromUI() {
    const serverSelection = configureJRebelModal.find('input[name="remote-servers-selection"]:checked').val();
    const selectedServerIds = serverSelection === 'EXPLICIT_INSTANCE' ?
      $('input[name="explicitly-selected-servers"]:checked').map((_, cb) => parseInt($(cb).val())).get() :
      [];
    return {
      serverSelection: serverSelection,
      selectedServerIds: selectedServerIds,
      deleteFilesOnSync: $('#remove-file-from-remote-when-not-found-in-ws').prop('checked') || false
    };
  }

  function configureJRebelOK() {
    configureJRebelModal.addClass('disable-div');
    configureJRebelModal.find('.info-message').addClass('displaynone');
    vscode.postMessage({ handlerId: 'projectpanel', type: 'configureJRebelOK', rebelConf: getRebelConfFromUI() });
  }

  configureJrebelModalOk.click(configureJRebelOK);

  function generateRebelXml() {
    configureJRebelModal.addClass('disable-div');
    configureJRebelModal.find('.info-message').addClass('displaynone');
    vscode.postMessage({ handlerId: 'projectpanel', type: 'generateRebelXml', rebelConf: getRebelConfFromUI() });
  }

  $('#regenerate-xml-button').click(generateRebelXml);

  function openRebelXml() {
    vscode.postMessage({ handlerId: 'projectpanel', type: 'openRebelXml' });
  }

  $('#open-rebel-xml-button').click(openRebelXml);

  bindTabAndContent(configureJRebelModal, 'general-tab-title', 'general-tab-content', 'general-tab-selected', true);
  bindTabAndContent(configureJRebelModal, 'remote-servers-tab-title', 'remote-servers-tab-content', 'general-tab-selected', false);

  $('#browse-configuration-file-location').click(e => {
    vscode.postMessage({ handlerId: 'projectpanel', type: 'openDirectoryDialog', subfolder: configureJRebelModal.find('#configuration-file-location').val() });
  });

  $('#generate-rebel-xml-by-ide').change(e => {
    $('#use-relative-paths-in-rebel-xml').prop('disabled', !e.target.checked);
  });

  $('#generate-rebel-xml-external').change(e => {
    $('#use-relative-paths-in-rebel-xml').prop('disabled', e.target.checked);
  });

  $('#override-configuration-file-location').change(e => {
    const disabled = !e.target.checked;
    $('#configuration-file-location').prop('disabled', disabled);
    $('#browse-configuration-file-location').prop('disabled', disabled);
  });

  function scrollToDialogTop() {
    $("#configure-jrebel-modal .modal-dialog")[0].scroll({ top: 0, behavior: 'smooth' });
  }

  $('input[name="remote-servers-selection"]').on('change', e => {
    let serversMode = $('input[name="remote-servers-selection"]:checked').val();
    switch (serversMode) {
      case 'OFF':
        $('#server-details-when-on').addClass('displaynone');
        break;
      case 'INSTANCE':
        $('#server-details-when-on').removeClass('displaynone');
        $('#server-details-when-instance').removeClass('displaynone');
        $('#server-details-when-explicit').addClass('displaynone');
        break;
      case 'EXPLICIT_INSTANCE':
        $('#server-details-when-on').removeClass('displaynone');
        $('#server-details-when-instance').addClass('displaynone');
        $('#server-details-when-explicit').removeClass('displaynone');
        break;
    }
  });

  /* === Configure JRebel Dialog ENDS === */

  function updateProjectRow(projectRow, rebelConf) {
    projectRow.find('.jrebel-onoff').prop('checked', rebelConf.isJRebelProject);
    projectRow.find('.remote-onoff').prop('checked', rebelConf.isJRebelRemotingProject);
    projectRow.find('.remote-onoff').prop('disabled', !rebelConf.isJRebelProject || !anyRemoteServerDefined && !rebelConf.isJRebelRemotingProject);
  }

  function updateDetailsRow(detailsRow, rebelConf) {
    detailsRow.find('.change-jrebel').prop('disabled', !rebelConf.isJRebelProject);
    detailsRow.find('.gen-type-label').html(rebelConf.isIdeRebelXmlGenerationType ? 'IDE plugin' : 'External build tool');
    detailsRow.find('.remote-servers-label').html(`${rebelConf.remotingConf.numServers} remote ${rebelConf.remotingConf.numServers === 1 ? 'server' : 'servers'}`);
  }

  $(window).on('message', $e => {
    const event = $e.originalEvent;
    switch (event.data.type) {
      case 'setConfigurationFileLocation':
        $('#configuration-file-location').val(event.data.path);
        break;
      case 'updateAvailableProjects':
        {
          const projectsTableBody = $("#projects-table-body");
          projectsTableBody.find(".cloned").remove();
          if (event.data.projects.length) {
            $('#no-projects-row').css('display', 'none');
            for (let project of event.data.projects) {
              const projectId = 'proj-' + encodeURIComponent(project.name);
              const projectRow = $('#--template-project-row').clone();
              projectRow.prop('id', projectId + '-project-row');
              projectRow.html(projectRow.html()
                .replace(/--template-project/g, projectId)
                .replace(/--TEMPLATE-PROJECT-NAME/g, project.displayName || project.name)
                .replace(/--template-pname/g, project.name)
              );
              updateProjectRow(projectRow, project.rebelConf);
              projectRow.css('display', 'table-row');
              projectRow.addClass("cloned");
              projectsTableBody.append(projectRow);

              const detailsRow = $('#--template-project-details-row').clone();
              detailsRow.prop('id', projectId + '-details-div');
              detailsRow.html(detailsRow.html()
                .replace(/--template-project/g, projectId)
                .replace(/--template-pname/g, project.name)
              );
              updateDetailsRow(detailsRow, project.rebelConf);
              detailsRow.addClass("cloned");
              projectsTableBody.append(detailsRow);
            }
            bindProjectRows();
          } else {
            $('#no-projects-row').css('display', 'table-row');
          }
        }
        break;
      case 'updateProjectRebelConf':
        {
          configureJRebelModal.removeClass('disable-div');
          const projectId = 'proj-' + encodeURIComponent(event.data.projectName);
          const projectRow = $('#' + projectId + '-project-row');
          updateProjectRow(projectRow, event.data.rebelConf);

          const detailsRow = $('#' + projectId + '-details-div');
          updateDetailsRow(detailsRow, event.data.rebelConf);

          if (event.data.closeDialog) {
            closeModal();
          }
          else if (event.data.rebelConf.message) {
            configureJRebelModal.find('.info-message').removeClass(['displaynone', 'red']).addClass('blue').html(event.data.rebelConf.message);
            scrollToDialogTop();
          }
        }
        break;
      case 'openConfigureJRebelDialog':
        {
          const rebelConf = event.data.rebelConf;
          showingRebelConf = rebelConf;
          if (rebelConf.isIdeRebelXmlGenerationType) {
            configureJRebelModal.find("#generate-rebel-xml-by-ide").click();
          }
          else {
            configureJRebelModal.find("#generate-rebel-xml-external").click();
          }
          configureJRebelModal.find("#use-relative-paths-in-rebel-xml").prop('checked', rebelConf.useRelativePaths);
          configureJRebelModal.find("#configuration-file-location, #browse-configuration-file-location").prop('disabled', !rebelConf.hasCustomXmlDirectory);
          configureJRebelModal.find("#override-configuration-file-location").prop('checked', rebelConf.hasCustomXmlDirectory);
          configureJRebelModal.find("#configuration-file-location").val(rebelConf.hasCustomXmlDirectory && rebelConf.customXmlDirectoryPath ? rebelConf.customXmlDirectoryPath : rebelConf.defaultXmlDirectory);

          configureJRebelModal.css('display', 'block');
          configureJRebelModal.find('.info-message').addClass('displaynone');
          $('#general-tab-title').trigger('click');
          $(`input[name="remote-servers-selection"][value="${rebelConf.remotingConf.serverSelection}"]`).trigger('click');
          if (event.data.enabledRemoteServers.length) {
            $('#enabled-servers-list').html(event.data.enabledRemoteServers.map(s => `<div>${s.name || s.url}</div>`).join('<div class="spacer-8"></div>'));
          }
          else {
            $('#enabled-servers-list').html('No active servers');
          }
          if (event.data.allRemoteServers.length) {
            $('#enabled-servers-checkboxes').html(event.data.allRemoteServers.map(s => `
              <div>
                <input type="checkbox" name="explicitly-selected-servers" id="expl-server-${s.id}" value="${s.id}" ${rebelConf.remotingConf.selectedServerIds.includes(s.id) ? 'checked' : ''}/>
                <label for="expl-server-${s.id}">${s.name || s.url}</label> 
              </div>
            `).join('<div class="spacer-8"></div>'));
          }
          else {
            $('#enabled-servers-checkboxes').html('No servers configured');
          }
          $('#remove-file-from-remote-when-not-found-in-ws').prop('checked', rebelConf.remotingConf.deleteFilesOnSync);
        }
        break;
      case 'showError':
        configureJRebelModal.removeClass('disable-div');
        configureJRebelModal.find('.info-message').removeClass(['displaynone', 'blue']).addClass('red').html(event.data.message);
        scrollToDialogTop();
        break;
      case 'updateRemotingAvailable':
        {
          anyRemoteServerDefined = event.data.available;
        }
        break;
    }
  });

  vscode.postMessage({ handlerId: 'projectpanel', type: 'projectpanelShown' });

});