// @ts-nocheck

$(function () {

  $('#usagedata-report').change(e => {
    handleReportRadioChange($(e.currentTarget));
  });

  $('#usagedata-report-anonymously').change(e => {
    handleReportAnonymouslyRadioChange($(e.currentTarget));
  });

  $('#usagedata-report-disabled').change(e => {
    handleReportDisabledRadioChange($(e.currentTarget));
  });

  function handleReportRadioChange(radio) {
    if (radio.prop("checked")) {
      vscode.postMessage({
        handlerId: 'usagedata', type: 'handleReportRadioChange'
      });
    }
  }

  function handleReportAnonymouslyRadioChange(radio) {
    if (radio.prop("checked")) {
      vscode.postMessage({
        handlerId: 'usagedata', type: 'handleReportAnonymouslyRadioChange'
      });
    }
  }

  function handleReportDisabledRadioChange(radio) {
    if (radio.prop("checked")) {
      vscode.postMessage({
        handlerId: 'usagedata', type: 'handleReportDisabledRadioChange'
      });
    }
  }

  $(window).on('message', $e => {
    const event = $e.originalEvent;
    const message = event.data; // The json data that the extension sent
    switch (message.type) {
      case 'ui.handleAdvancedSettingsData':
        {
          $('#usagedata-report').prop('checked', message.data.metricsConsentState === "PERSONAL_METRICS");
          $('#usagedata-report-anonymously').prop('checked', message.data.metricsConsentState === "ANONYMOUS_METRICS");
          $('#usagedata-report-disabled').prop('checked', message.data.metricsConsentState === "NO_METRICS");
          break;
        }
    }
  });

});