// @ts-nocheck

$(function () {

  $('#switch-to-ide-rebel-xml-gen').on('click', () => {
    vscode.postMessage({ handlerId: 'xmlgeneration', type: 'switchToIdeRebelXmlGeneration' });
    return false;
  });

  $('#switch-to-ext-rebel-xml-gen').on('click', () => {
    vscode.postMessage({ handlerId: 'xmlgeneration', type: 'switchToExternalRebelXmlGeneration' });
    return false;
  });

  $('#auto-switch-to-ext-rebel-xml-gen').on('click', () => {
    const externalAutoconvertDisabled = !$('#auto-switch-to-ext-rebel-xml-gen').prop('checked');
    vscode.postMessage({ handlerId: 'xmlgeneration', type: 'setExternalAutoconvertDisabled', externalAutoconvertDisabled: externalAutoconvertDisabled });
  });

  $(window).on('message', $e => {
    const event = $e.originalEvent;
    switch (event.data.type) {
      case 'updateRebelXmlGenerationSettings':
        const settings = event.data.settings;
        $('#ide-gen-modules-count').text(settings.ideGenerationModulesCount === 1 ? '1 module' : `${settings.ideGenerationModulesCount} modules`);
        $('#ext-gen-modules-count').text(settings.externalGenerationModulesCount === 1 ? '1 module' : `${settings.externalGenerationModulesCount} modules`);

        $('#auto-switch-to-ext-rebel-xml-gen').prop('checked', !settings.externalAutoconvertDisabled);
        break;
    }
  });

  vscode.postMessage({ handlerId: 'xmlgeneration', type: 'xmlGenerationShown' });
});
